'''''''''''''''''''''''''''''''''''''''''''''''''''''''
''  Scanner
''
''  Drives servo to scan the world using
''  sonar and reports distances.
''
''  Written April 2008 by Chuck Rice
'''''''''''''''''''''''''''''''''''''''''''''''''''''''

con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  'cValuesPerRow                 = 100
  cPluseTimePerDegree           = 1000/180

'Signal Constants

  cOutput       = %1
  cInput        = %0
  cHigh         = %1
  cLow          = %0


  'cServoPin      =  5                                      
  'cSonarTrigger  =  6                                      
  'cSonarData     =  7                                      
  
OBJ
  G             :     "my_Globals"
  Sonar         :     "Simple_Serial"   'Sonar is a serial, 9600 baud device
  Servo         :     "Servo32v3"

var

  long  Stack[50]             'Stack space for new cog
  long  scanCog
  long  map
  byte servoPin, sonarTrigger, sonarData
  
pub start(theServoPin,theSonarTrigger,theSonarData,theMap) | rc

  servoPin     := theServoPin
  sonarTrigger := theSonarTrigger
  sonarData    := theSonarData
  map          := themap
 
  servo.Set(servoPin, 1500)
  servo.Start

  dira[sonarTrigger]:=cOutput                          ' Trigger is output
  dira[sonarData]   :=cInput                           ' Data is input
                           
  rc := Sonar.init(7,    -1, -9600)           ' rxPin, txPin, baud
  scanCog := cognew(doPan,@Stack)

  return rc


  
pri doPan |  pulse, row, distance
  
repeat
  'doFade
  repeat row from 0 to g#cScannerMaxRows 
    pulse := 1000 + (row*10*cPluseTimePerDegree)
    servo.Set(servoPin, pulse)
    'waitcnt(cnt+(clkfreq/10))                        'wait 1/10 second

    distance := doPing    
    byte[map][row] := distance
    
   
pri doFade  | i
  repeat i from 0 to (g#cScannerMaxRows)
    if byte[map][i] > 0
            byte[map][i] -= 1
return

pri doPing  : k | k1, k2, k3, k4, k5

    dira[sonarTrigger]:=cOutput                          ' Trigger is output

    outa[sonarTrigger] := cLow
    waitcnt(cnt+(clkfreq/20))                        'wait 1/10 second

    outa[sonarTrigger] := cHigh
    waitcnt(cnt+(clkfreq/20))                        'wait 1/10 second

    k1 := Sonar.rx                                      ' Get the "R", but ignore it
    k2 := Sonar.rx-"0"                                  ' First digit   
    k3 := Sonar.rx-"0"                                  ' Second
    k4 := Sonar.rx-"0"                                  ' Third
    k5 := Sonar.rx                                      ' Get CR, but ignore it
    
    k := k2*100 + k3*10 + k4

  return k
  

dat